/// Test if `v4` generates unique UUIDs

import 'package:test/test.dart';
import 'package:uuid/uuid.dart';
import 'package:uuid/uuid_util.dart';

// The cryptoRNG test takes about one minute to run per 100 thousand UUIDs.

const numToGenerate = 300 * 10000;

void generate(Uuid generator) {
  final values = <String>{}; // set of strings

  var numDuplicates = 0;
  for (var i = 0; i < numToGenerate; i++) {
    final uuid = generator.v4();

    if (!values.contains(uuid)) {
      values.add(uuid);
    } else {
      numDuplicates++;
      // print('$i: duplicate UUID generated: $uuid');
    }
  }

  expect(numDuplicates, equals(0), reason: 'duplicate UUIDs generated');
}

void main() {
  group('v4', () {
    test('default', () {
      generate(Uuid());
    });

    test('mathRNG', () {
      generate(Uuid(options: <String, Object>{'grng': UuidUtil.mathRNG}));
    });

    test('cryptoRNG', () {
      //generate(Uuid(options: <String, Object>{'grng': UuidUtil.cryptoRNG}));
    });
  });
}
